const TronWeb = require('../dist/TronWeb.node.js'); // require('tronweb');
const HttpProvider = TronWeb.providers.HttpProvider;

const fullNode = new HttpProvider('https://api.shasta.trongrid.io');
const solidityNode = new HttpProvider('https://api.shasta.trongrid.io');
const eventServer = 'https://api.shasta.trongrid.io';
const privateKey = '63250d8604b5a8e67cde2ac900a97e841a62679d3155ee265a4d8128b1798a4d';

// const fullNode = new HttpProvider('http://127.0.0.1:8090');
// const solidityNode = new HttpProvider('http://127.0.0.1:8091');
// const eventServer = 'http://127.0.0.1:8060';
// const privateKey = 'da146374a75310b9666e834ee4ad0866d6f4035967bfc76217c5a495fff9f0d0';
// 41928c9af0651632157ef27a2cf17ca72c575a4d21

const app = async () => {
    const tronWeb = new TronWeb(
        fullNode,
        solidityNode,
        eventServer,
        privateKey
    );

    const code = tronWeb.utils.code;
    const bytes = tronWeb.utils.bytes;
    const {utils} = require('ethers');

    const keccak256 = utils.keccak256;

    // const {keccak256} = require('../src/utils/ethersUtils')
    tronWeb.setDefaultBlock('latest');

    const nodes = await tronWeb.isConnected();
    const connected = !Object.entries(nodes).map(([name, connected]) => {
        if (!connected)
            console.error(`Error: ${name} is not connected`);

        return connected;
    }).includes(false);

    if (!connected)
        return;

    // Generated account
    // - Private Key: F8A6D31C0AD91C5AB99730FF35C8422A0151B89DB3342A6C7797435EC43A2DD8
    // - Public Key:  043A4477F299003B918FC0DA289C97EBA99C4EF2AAD1712A4F47FFBC3AD98837B907FC142243499D0B0249609456BB9FDD42B51E8ACB8C9445B45E53768C401440
    // Address
    // - Base58: TJnCTJf6CVvB8KyHoJ4c8PQETmP6jjydos
    // - Hex:    4160A419765B4A08273658652A68944F372251A4B4
    // - Valid:  true


    // let address = tronWeb.address.fromPrivateKey(privateKey);
    // address = tronWeb.address.toHex(address);
    // console.log(address)



    // Generated account
    // - Private Key: 8865AB75E018F79222FABC51C83E6AAC4E4B5FFD43DBA920EB3F9F01B87732A1
    // - Public Key:  04A45D13491E312FF98625DCF89217B948F1EDBE3755BF2FE78C9541FA020059615D36D6954AC89383B72E4F157204D355C4A748930141DECA745B048DA2E00859
    // Address
    // - Base58: TRHD2qVBe565tfJY5SdHGnoY7ftzpGqQnr
    // - Hex:    41A7F1664FD08B31DA597840BAE486913A998B5390
    // - Valid:  true

    // const account = await tronWeb.createAccount();
    // const isValid = tronWeb.isAddress(account.address.hex);
    //
    // console.group('\nGenerated account');
    // console.log('- Private Key:', account.privateKey.toLowerCase());
    // console.log('- Public Key: ', account.publicKey.toLowerCase());
    // console.group('Address')
    // console.log('- Base58:', account.address.base58);
    // console.log('- Hex:   ', account.address.hex);
    // console.log('- Valid: ', isValid, '\n')
    // console.groupEnd();
    // console.groupEnd();

    tronWeb.trx.sendTransaction('TFysCB929XGezbnyumoFScyevjDggu3BPq', 200000000000000, (err, result) => {
        if(err)
            return console.error(err);

        console.group('Send TRX transaction');
        console.log('- Result:\n' + JSON.stringify(result, null, 2), '\n');
        console.groupEnd();
    });


    // update account permission
    // let ownerAddress = '41928c9af0651632157ef27a2cf17ca72c575a4d21';
    // let ownerPk = 'da146374a75310b9666e834ee4ad0866d6f4035967bfc76217c5a495fff9f0d0';
    // let ownerPermission = { type: 0, permission_name: 'owner' };
    // ownerPermission.threshold = 1;
    // ownerPermission.keys  = [];
    //
    // let activePermission = { type: 2, permission_name: 'active0' };
    // activePermission.threshold = 1;
    // activePermission.operations = '7fff1fc0037e0000000000000000000000000000000000000000000000000000';
    // activePermission.keys = [];
    //
    // let witnessPermission = { type: 1, permission_name: 'witness' };
    // witnessPermission.threshold = 1;
    // witnessPermission.keys = [];
    //
    //
    // let weight = 1;
    // ownerPermission.keys.push({ address: '41A7F1664FD08B31DA597840BAE486913A998B5390', weight: weight });
    // ownerPermission.keys.push({ address: '412b4d858c87c4bd96e0bb86877a0fe7d3536fd7f0', weight: weight });
    // ownerPermission.keys.push({ address: '41f8e95a62eddf89004028284449b1b2052ac6e6bd', weight: weight });

    // activePermission.keys.push({ address: '41A7F1664FD08B31DA597840BAE486913A998B5390', weight: weight });
    // activePermission.keys.push({ address: '412b4d858c87c4bd96e0bb86877a0fe7d3536fd7f0', weight: weight });
    // activePermission.keys.push({ address: '41f8e95a62eddf89004028284449b1b2052ac6e6bd', weight: weight });

    // witnessPermission.keys.push({ address: '41928c9af0651632157ef27a2cf17ca72c575a4d21', weight: weight });

    // const updateTransaction = await tronWeb.transactionBuilder.updateAccountPermissions(
    //     ownerAddress,
    //     ownerPermission,
    //     witnessPermission,
    //     [activePermission]
    // );

    // broadcast update transaction
    // const signedUpdateTransaction = await tronWeb.trx.sign(updateTransaction, ownerPk, null, false);
    // const tx = await tronWeb.trx.broadcast(signedUpdateTransaction);
    // console.log(tx)
    //
    //
    // console.log('F8A6D31C0AD91C5AB99730FF35C8422A0151B89DB3342A6C7797435EC43A2DD8'.toLowerCase())

    // create transaction
    // const transaction = await tronWeb.transactionBuilder.sendTrx('414EC557621659610AB418BEB1FB917BA5E7D9393C', 10000);
    // // transaction.raw_data.contract[0].Permission_id = 2
    // // console.log(JSON.stringify(transaction))
    // // console.log(transaction)
    // const signedUpdateTransaction = await tronWeb.trx.sign(transaction, 'da146374a75310b9666e834ee4ad0866d6f4035967bfc76217c5a495fff9f0d0', null, false);
    // const tx = await tronWeb.trx.broadcast(signedUpdateTransaction);
    // console.log(tx)
    // console.log('origin transaction', JSON.stringify(transaction))

    // check sign weight get new transaction id
    //  let signWeight = await tronWeb.trx.getSignWeight(transaction);
    //  console.log('get new transaction id', signWeight)

    // reset transaction id
    // transaction.txID = signWeight.transaction.txid

    // sign
    // let signedTransaction = await tronWeb.trx.addTransactionSign(transaction, '242E4287A55B55B91D09C3DAA101AE043AD1CE01A981C9C7E69D173B240CAD16');
    // console.log(JSON.stringify(signedTransaction))
    // signedTransaction.raw_data.contract[0].Permission_id = 2
    //
    // // let raw1 = JSON.stringify(transaction.raw_data)
    // // let raw2 = JSON.stringify(signedTransaction.raw_data)
    //
    // // console.log(raw1 === raw2)
    // console.log('raw1Hex', transaction.txID, keccak256(Buffer.from(transaction.raw_data_hex), 'utf-8'))
    // console.log('raw2Hex', signedTransaction.txID, keccak256(Buffer.from(signedTransaction.raw_data_hex), 'utf-8'))


    // signWeight = await tronWeb.trx.getSignWeight(signedTransaction);
    // console.log('get new transaction id', signWeight)

    // const result = await tronWeb.trx.broadcast(JSON.stringify(signedTransaction))
    // console.log('broadcast result', result)
    // signedTransaction.raw_data.contract[0].Permission_id = 2

    // check sign weight again
    // signWeight = await tronWeb.trx.getSignWeight(signedTransaction)
    // console.log('signWeight after sign', signWeight)
    //
    // const approvedList = await tronWeb.trx.getApprovedList(signedTransaction)
    // console.log('approved list', approvedList)
    //
    // const result = await tronWeb.trx.broadcast(signedTransaction)
    // console.log('broadcast result', result)


    // console.log(transaction)
    //
    // delete transaction.raw_data_hex
    // const byteArray = code.stringToBytes(transaction.raw_data.toString())
    // console.log(byteArray)
    // const hex = bytes.byteArray2hexStr(byteArray)
    // console.log(1, hex)
    // transaction.raw_data_hex = hex
    // console.log(transaction)
    //
    // // console.log(transaction.raw_data.contract[0])
    // // console.log(transaction)
    // const signedTransaction = await tronWeb.trx.addTransactionSign(transaction, '242E4287A55B55B91D09C3DAA101AE043AD1CE01A981C9C7E69D173B240CAD16');


    // let signedTransaction = await tronWeb.trx.sign(transaction, '242E4287A55B55B91D09C3DAA101AE043AD1CE01A981C9C7E69D173B240CAD16', null, true);
    // console.log(signedTransaction)
    // signedTransaction.raw_data.contract[0].Permission_id = 2
    // let signedTransaction = await tronWeb.trx.sign(transaction, '242E4287A55B55B91D09C3DAA101AE043AD1CE01A981C9C7E69D173B240CAD16', null, true);
    // signedTransaction = await tronWeb.trx.addTransactionSign(transaction, 'f75bb82deede87c937cb737d42091b0714c7216aa54601c412eea1c3cb03fa96');
    // console.log('sign2', signedTransaction)
    // signWeight = await tronWeb.trx.getSignWeight(signedTransaction);
    // console.log(signWeight)
    //
    // signedTransaction = await tronWeb.trx.addTransactionSign(transaction, 'd089d6a6055ee0918bac56ec6b26524865a07a2963271682713151a1fa6227f0');
    // console.log('sign3', signedTransaction)
    // signWeight = await tronWeb.trx.getSignWeight(signedTransaction);
    // console.log(signWeight)
    //
    // const approvedList = await tronWeb.trx.getApprovedList(transaction)
    // console.log('approved list', approvedList)
    //
    // const result = await tronWeb.trx.broadcast(signedTransaction)
    // console.log('broadcast result', result)

    // create proposal
    // const account = await tronWeb.address.fromPrivateKey('da146374a75310b9666e834ee4ad0866d6f4035967bfc76217c5a495fff9f0d0');
    // console.log(account)

    // const transaction = await tronWeb.transactionBuilder.createProposal([ {"key": 11, "value": 10} ], 'TXyZjVcYurrbE43b2MfMtN34uA3tJL85zy');
    // console.log(transaction)
    // const signedTransaction = await tronWeb.trx.sign(transaction, 'bd74406eecc2915d2b69e95c9f322b354519ff57e587498f5b06d3d413596588', null, true)
    // console.log(signedTransaction)
    // const result = await tronWeb.trx.broadcast(signedTransaction)
    // console.log(result)

    // approve proposal
    // const transaction = await tronWeb.transactionBuilder.voteProposal(1, true, '41F16412B9A17EE9408646E2A21E16478F72ED1E95')
    // console.log(transaction)
    // const signedTransaction = await tronWeb.trx.sign(transaction, 'bd74406eecc2915d2b69e95c9f322b354519ff57e587498f5b06d3d413596588', null, true)
    // console.log(signedTransaction)
    // const result = await tronWeb.trx.broadcast(signedTransaction)
    // console.log(result)

    // trc20 balance
    // const usdtContractAddress = 'TDuetDuG2FTG6TqbpjRTApn5LpsQANFaBm'
    // let usdt = await tronWeb.contract().at(usdtContractAddress)
    // let balance = await usdt.balanceOf('TQaKCFMqxShGVXeeiZG9BMd55ePN8xVPmn').call()
    // console.log(new Number(parseInt(balance).toString()).toLocaleString())

    // create witness
    // const transaction = await tronWeb.transactionBuilder.applyForSR('41343786E23F295D943030CB3D6B82BA7F1991BF4E', 'http://test1112.com');
    // const signedTransaction = await tronWeb.trx.sign(transaction, '5e016836b4d4f17ca0df2d5de56d1f88968cb032032abf2fc067dec4734836b6', null, true)
    // const result = await tronWeb.trx.broadcast(signedTransaction)
    // console.log(result)

    // vote
    // const transaction = await tronWeb.transactionBuilder.vote({srAddress: '41092318F5A0B4239CCF563C7A9EC8563EDF1FB58C', voteCount: 10}, '41CD381314808F04DD424D735F349CCC40BD1B8F61');
    // console.log(transaction)
    // const signedTransaction = await tronWeb.trx.sign(transaction, '2f13a65a47ec0aae0ec475dae9d756a6046a42e4cecd72038398a0bf947533e5', null, true)
    // const result = await tronWeb.trx.broadcast(signedTransaction)
    // console.log(result)

    // freeze balance
    // const params = [
    //     [10000000, 3, 'BANDWIDTH', '41CD381314808F04DD424D735F349CCC40BD1B8F61']
    // ];
    //
    // for (let param of params) {
    //     const transaction = await tronWeb.transactionBuilder.freezeBalance(...param)
    //     const signedTransaction = await tronWeb.trx.sign(transaction, '2f13a65a47ec0aae0ec475dae9d756a6046a42e4cecd72038398a0bf947533e5', null, true)
    //     const result = await tronWeb.trx.broadcast(signedTransaction)
    //     console.log(result)
    // }

};

app();
